//
//  RootViewController.m
//  CountryDB
//
//  Created by Holger Hinzberg on 10.04.11.
//  Copyright 2011 Cocoa-Coding. All rights reserved.
//

#import "RootViewController.h"

@implementation RootViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // Hat man einen Titel, gibt es 
    // automatisch auch einen Button
    // zur Navigation.
    self.navigationItem.title = @"Länder";
        
    // CountryViewController instanzieren und die 
    // Datei der grafische Oberfläche zuweisen.
    countryView = [[CountryViewController alloc] 
    initWithNibName:@"CountryViewController" bundle:nil];
    
    countryArray = [[NSMutableArray alloc] init];
    
    Country *aCounty;
    
    aCounty = [[Country alloc] init];
    aCounty.countryName = @"Deutschland";
    aCounty.capital = @"Berlin";
    aCounty.area = @"357.021 km\u00b2";
    aCounty.population = @"81.757.600";
    [countryArray addObject:aCounty];
    
    aCounty = [[Country alloc] init];
    aCounty.countryName = @"Frankreich";
    aCounty.capital = @"Paris";
    aCounty.area = @"674.843 km\u00b2";
    aCounty.population =@"65.447.374";
    [countryArray addObject:aCounty];
    
    aCounty = [[Country alloc] init];
    aCounty.countryName = @"Italien";
    aCounty.capital = @"Rom";
    aCounty.area = @"301.338 km\u00b2";
    aCounty.population = @"60.418.711";
    [countryArray addObject:aCounty];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

/*
 // Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations.
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
 */

// Customize the number of sections in the table view.
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [countryArray count];
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
    }

    Country *aCounty = 
    [countryArray objectAtIndex:indexPath.row];
    cell.textLabel.text = aCounty.countryName;
    
    return cell;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete)
    {
        // Delete the row from the data source.
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }
    else if (editingStyle == UITableViewCellEditingStyleInsert)
    {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view.
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // 1. Das passende Objekt holen
    Country *aCounty = 
    [countryArray objectAtIndex:indexPath.row];
    
    // 2. Das Land an die Detailansicht übergeben
    countryView.aCountry = aCounty;
    
    // 3. Anzeigen
    [self.navigationController pushViewController:
     countryView animated:YES];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Relinquish ownership any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload
{
    // Detailansicht freigeben
    [countryView release];
    
     // Das Array wieder freigeben
     [countryArray release];
        
    [super viewDidUnload];
}

- (void)dealloc
{
    [super dealloc];
}

@end
